#include "widget.h"
#include "ui_widget.h"
#include "globalMaze.h"

Widget::Widget(QWidget *parent)
    : QWidget(parent)
    , ui(new Ui::Widget)
{

    ui->setupUi(this);   
    foreach (QString engine, QTextToSpeech::availableEngines())
    {
        qDebug()<<engine;
    }
    this->flagStartStop = false;
    mTextToSpeech = new QTextToSpeech("sapi",this);//uso engine sapi di Windows
    mTextToSpeech->setLocale(QLocale(QLocale::Italian,QLocale::Italy));//setta lingua italiana e paese Italia
    mTextToSpeech->setRate(-0.1);
    mTextToSpeech->setPitch(0);
    mTextToSpeech->setVolume(1.0);//max volume
    mTextToSpeech->say("Benvnuto nel labirinto virtuale");
    mTextToSpeech->say("Prova a risolvere il labirinto utilizzando i pulsanti avanti,indietro, destra e sinistra");
    mTextToSpeech->say("Sei pronto?");
    mTextToSpeech->say("Buon divertimento");
    mTextToSpeech->say("Premmi play per iniziare a giocare");
    ui->labelWallUp->setStyleSheet("background-color:black");
    ui->labelWallLeft->setStyleSheet("background-color:black");
    ui->labelWallDown->setStyleSheet("background-color:black");
    ui->labelWallRight->setStyleSheet("background-color:black");
    ui->labelCornerTopLeft->setStyleSheet("background-color:black");
    ui->labelCornerTopRight->setStyleSheet("background-color:black");
    ui->labelCornerBottonLeft->setStyleSheet("background-color:black");
    ui->labelCornerBottonRight->setStyleSheet("background-color:black");
    mCoreMaze = new CoreMaze(this);
    mDialogMaze = new DialogMaze(this);
}


Widget::~Widget()
{
    mCoreMaze->terminate();//chiudo il thread
    mCoreMaze->wait();    
    delete ui;
}

void Widget::keyPressEvent(QKeyEvent *event)
{
    if(QString(event->key()) == "W")
    {
        ui->pushButtonUp->animateClick();
    }
    else
        if(QString(event->key()) == "S")
        {
            ui->pushButtonDown->animateClick();
        }
        else
            if(QString(event->key()) == "A")
            {
                ui->pushButtonLeft->animateClick();
            }
            else
                if(QString(event->key()) == "D")
                {
                   ui->pushButtonRight->animateClick();

                }
                else
                    if(QString(event->key()) == "F")
                    {
                       //ui->pushButtonFire->animateClick();
                    }
                    else
                        if(QString(event->key()) == "G")
                        {
                            ui->pushButtonSpace->animateClick();
                        }
}

void Widget::on_pushButtonUp_clicked()
{    
    mCoreMaze->key = "W";
}

void Widget::on_pushButtonRight_clicked()
{   
     mCoreMaze->key = "D";
}

void Widget::on_pushButtonDown_clicked()
{   
     mCoreMaze->key = "S";
}

void Widget::on_pushButtonLeft_clicked()
{   
     mCoreMaze->key = "A";
}

void Widget::on_pushButtonFire_clicked()
{    
     mCoreMaze->key = "F";
}

void Widget::on_pushButtonSpace_clicked()
{    
     mCoreMaze->key = "G";
}

void Widget::turnOnOffWall(int wall)
{
    emit updatePerson();
    bool wallUp = wall & 0b000001;
    bool wallRight = wall & 0b000010;
    bool wallDown = wall & 0b000100;
    bool wallLeft = wall & 0b001000;

    if(wallDown && wallLeft && wallUp && !wallRight)//dx
    {
        ui->labelWallUp->setStyleSheet("background-color:red");
        ui->labelWallRight->setStyleSheet("background-color:no color");
        ui->labelWallDown->setStyleSheet("background-color:red");
        ui->labelWallLeft->setStyleSheet("background-color:red");
        ui->labelCornerTopLeft->setStyleSheet("background-color:red");
        ui->labelCornerTopRight->setStyleSheet("background-color:red");
        ui->labelCornerBottonLeft->setStyleSheet("background-color:red");
        ui->labelCornerBottonRight->setStyleSheet("background-color:red");
    }
    else
        if(wallDown && wallRight && wallUp && !wallLeft)//sx
        {
            ui->labelWallUp->setStyleSheet("background-color:red");
            ui->labelWallRight->setStyleSheet("background-color:red");
            ui->labelWallDown->setStyleSheet("background-color:red");
            ui->labelWallLeft->setStyleSheet("background-color:no color");
            ui->labelCornerTopLeft->setStyleSheet("background-color:red");
            ui->labelCornerTopRight->setStyleSheet("background-color:red");
            ui->labelCornerBottonLeft->setStyleSheet("background-color:red");
            ui->labelCornerBottonRight->setStyleSheet("background-color:red");
        }
        else
            if(wallUp && wallDown && !wallLeft && !wallRight)//sx  dx
            {
                ui->labelWallUp->setStyleSheet("background-color:red");
                ui->labelWallRight->setStyleSheet("background-color:no color");
                ui->labelWallDown->setStyleSheet("background-color:red");
                ui->labelWallLeft->setStyleSheet("background-color:no color");
                ui->labelCornerTopLeft->setStyleSheet("background-color:red");
                ui->labelCornerTopRight->setStyleSheet("background-color:red");
                ui->labelCornerBottonLeft->setStyleSheet("background-color:red");
                ui->labelCornerBottonRight->setStyleSheet("background-color:red");
            }
            else
                if(wallLeft && wallRight && !wallDown && !wallUp)//sotto sopra
                {
                    ui->labelWallUp->setStyleSheet("background-color:no color");
                    ui->labelWallRight->setStyleSheet("background-color:red");
                    ui->labelWallDown->setStyleSheet("background-color:no color");
                    ui->labelWallLeft->setStyleSheet("background-color:red");
                    ui->labelCornerTopLeft->setStyleSheet("background-color:red");
                    ui->labelCornerTopRight->setStyleSheet("background-color:red");
                    ui->labelCornerBottonLeft->setStyleSheet("background-color:red");
                    ui->labelCornerBottonRight->setStyleSheet("background-color:red");
                }
                else
                    if(wallLeft && wallUp && wallRight && !wallDown)//sotto
                    {
                        ui->labelWallUp->setStyleSheet("background-color:red");
                        ui->labelWallRight->setStyleSheet("background-color:red");
                        ui->labelWallDown->setStyleSheet("background-color:no color");
                        ui->labelWallLeft->setStyleSheet("background-color:red");
                        ui->labelCornerTopLeft->setStyleSheet("background-color:red");
                        ui->labelCornerTopRight->setStyleSheet("background-color:red");
                        ui->labelCornerBottonLeft->setStyleSheet("background-color:red");
                        ui->labelCornerBottonRight->setStyleSheet("background-color:red");
                    }
                    else
                        if(wallUp  && wallRight && !wallLeft && !wallDown)//sx sotto
                        {
                            ui->labelWallUp->setStyleSheet("background-color:red");
                            ui->labelWallRight->setStyleSheet("background-color:red");
                            ui->labelWallDown->setStyleSheet("background-color:no color");
                            ui->labelWallLeft->setStyleSheet("background-color:no color");
                            ui->labelCornerTopLeft->setStyleSheet("background-color:red");
                            ui->labelCornerTopRight->setStyleSheet("background-color:red");
                            ui->labelCornerBottonLeft->setStyleSheet("background-color:no color");
                            ui->labelCornerBottonRight->setStyleSheet("background-color:red");
                        }
                        else
                            if(wallUp && wallDown && wallLeft && wallRight)// nessuna direzione
                            {
                                ui->labelWallUp->setStyleSheet("background-color:red");
                                ui->labelWallRight->setStyleSheet("background-color:red");
                                ui->labelWallDown->setStyleSheet("background-color:red");
                                ui->labelWallLeft->setStyleSheet("background-color:red");
                                ui->labelCornerTopLeft->setStyleSheet("background-color:red");
                                ui->labelCornerTopRight->setStyleSheet("background-color:red");
                                ui->labelCornerBottonLeft->setStyleSheet("background-color:red");
                                ui->labelCornerBottonRight->setStyleSheet("background-color:red");
                            }
                            else
                                if(!wallDown && !wallLeft && !wallUp && !wallRight)// tutte le direzioni
                                {
                                    ui->labelWallUp->setStyleSheet("background-color:no color");
                                    ui->labelWallRight->setStyleSheet("background-color:no color");
                                    ui->labelWallDown->setStyleSheet("background-color:no color");
                                    ui->labelWallLeft->setStyleSheet("background-color:no color");
                                    ui->labelCornerTopLeft->setStyleSheet("background-color:no color");
                                    ui->labelCornerTopRight->setStyleSheet("background-color:no color");
                                    ui->labelCornerBottonLeft->setStyleSheet("background-color:no color");
                                    ui->labelCornerBottonRight->setStyleSheet("background-color:no color");
                                }
                                else
                                    if(!wallDown && !wallRight && wallUp && !wallLeft)//sotto sx dx
                                    {
                                        ui->labelWallUp->setStyleSheet("background-color:red");
                                        ui->labelWallRight->setStyleSheet("background-color:no color");
                                        ui->labelWallDown->setStyleSheet("background-color:no color");
                                        ui->labelWallLeft->setStyleSheet("background-color:no color");
                                        ui->labelCornerTopLeft->setStyleSheet("background-color:red");
                                        ui->labelCornerTopRight->setStyleSheet("background-color:red");
                                        ui->labelCornerBottonLeft->setStyleSheet("background-color:no color");
                                        ui->labelCornerBottonRight->setStyleSheet("background-color:no color");
                                    }
                                    else
                                        if(!wallUp && !wallDown && !wallLeft && wallRight)//sotto sopra sx
                                        {
                                            ui->labelWallUp->setStyleSheet("background-color:no color");
                                            ui->labelWallRight->setStyleSheet("background-color:red");
                                            ui->labelWallDown->setStyleSheet("background-color:no color");
                                            ui->labelWallLeft->setStyleSheet("background-color:no color");
                                            ui->labelCornerTopLeft->setStyleSheet("background-color:no color");
                                            ui->labelCornerTopRight->setStyleSheet("background-color:red");
                                            ui->labelCornerBottonLeft->setStyleSheet("background-color:no color");
                                            ui->labelCornerBottonRight->setStyleSheet("background-color:red");
                                        }
                                        else
                                            if(!wallLeft && !wallRight && wallDown && !wallUp)//sopra sx dx
                                            {
                                                ui->labelWallUp->setStyleSheet("background-color:no color");
                                                ui->labelWallRight->setStyleSheet("background-color:no color");
                                                ui->labelWallDown->setStyleSheet("background-color:red");
                                                ui->labelWallLeft->setStyleSheet("background-color:no color");
                                                ui->labelCornerTopLeft->setStyleSheet("background-color:no color");
                                                ui->labelCornerTopRight->setStyleSheet("background-color:no color");
                                                ui->labelCornerBottonLeft->setStyleSheet("background-color:red");
                                                ui->labelCornerBottonRight->setStyleSheet("background-color:red");
                                            }
                                            else
                                                if(wallLeft && !wallUp && !wallRight && !wallDown)//sotto sopra dx
                                                {
                                                    ui->labelWallUp->setStyleSheet("background-color:no color");
                                                    ui->labelWallRight->setStyleSheet("background-color:no color");
                                                    ui->labelWallDown->setStyleSheet("background-color:no color");
                                                    ui->labelWallLeft->setStyleSheet("background-color:red");
                                                    ui->labelCornerTopLeft->setStyleSheet("background-color:red");
                                                    ui->labelCornerTopRight->setStyleSheet("background-color:no color");
                                                    ui->labelCornerBottonLeft->setStyleSheet("background-color:red");
                                                    ui->labelCornerBottonRight->setStyleSheet("background-color:no color");
                                                }
                                                else
                                                    if(wallUp  && !wallRight && wallLeft && !wallDown)//sotto dx
                                                    {
                                                        ui->labelWallUp->setStyleSheet("background-color:red");
                                                        ui->labelWallRight->setStyleSheet("background-color:no color");
                                                        ui->labelWallDown->setStyleSheet("background-color:no color");
                                                        ui->labelWallLeft->setStyleSheet("background-color:red");
                                                        ui->labelCornerTopLeft->setStyleSheet("background-color:red");
                                                        ui->labelCornerTopRight->setStyleSheet("background-color:red");
                                                        ui->labelCornerBottonLeft->setStyleSheet("background-color:red");
                                                        ui->labelCornerBottonRight->setStyleSheet("background-color:no color");
                                                    }
                                                    else
                                                        if(!wallUp && wallDown && !wallLeft && wallRight)//sopra sx
                                                        {
                                                            ui->labelWallUp->setStyleSheet("background-color:no color");
                                                            ui->labelWallRight->setStyleSheet("background-color:red");
                                                            ui->labelWallDown->setStyleSheet("background-color:red");
                                                            ui->labelWallLeft->setStyleSheet("background-color:no color");
                                                            ui->labelCornerTopLeft->setStyleSheet("background-color:no color");
                                                            ui->labelCornerTopRight->setStyleSheet("background-color:red");
                                                            ui->labelCornerBottonLeft->setStyleSheet("background-color:red");
                                                            ui->labelCornerBottonRight->setStyleSheet("background-color:red");
                                                        }
                                                        else
                                                            if(!wallUp  && !wallRight && wallLeft && wallDown)//sopra dx
                                                            {
                                                                ui->labelWallUp->setStyleSheet("background-color:no color");
                                                                ui->labelWallRight->setStyleSheet("background-color:no color");
                                                                ui->labelWallDown->setStyleSheet("background-color:red");
                                                                ui->labelWallLeft->setStyleSheet("background-color:red");
                                                                ui->labelCornerTopLeft->setStyleSheet("background-color:red");
                                                                ui->labelCornerTopRight->setStyleSheet("background-color:no color");
                                                                ui->labelCornerBottonLeft->setStyleSheet("background-color:red");
                                                                ui->labelCornerBottonRight->setStyleSheet("background-color:no color");
                                                            }
                                                            else
                                                                if(!wallUp && wallDown && wallLeft && wallRight)//sopra
                                                                {
                                                                    ui->labelWallUp->setStyleSheet("background-color:no color");
                                                                    ui->labelWallRight->setStyleSheet("background-color:red");
                                                                    ui->labelWallDown->setStyleSheet("background-color:red");
                                                                    ui->labelWallLeft->setStyleSheet("background-color:red");
                                                                    ui->labelCornerTopLeft->setStyleSheet("background-color:red");
                                                                    ui->labelCornerTopRight->setStyleSheet("background-color:red");
                                                                    ui->labelCornerBottonLeft->setStyleSheet("background-color:red");
                                                                    ui->labelCornerBottonRight->setStyleSheet("background-color:red");
                                                                }
}

void Widget::on_pushButton_clicked()
{
    if(this->flagStartStop == false)
    {        
        mDialogMaze->show();
        connect(mCoreMaze, &CoreMaze::setWall, this, &Widget::turnOnOffWall);
        connect(mCoreMaze, &CoreMaze::sendMessage, mTextToSpeech, &QTextToSpeech::say);
        connect(this,&Widget::updatePerson,mDialogMaze,&DialogMaze::movePerson);
        mCoreMaze->start();//inizio il gioco maze
        ui->pushButton->setText("STOP");
        mTextToSpeech->stop();
        this->flagStartStop = true;
    }
    else
    {
        switch(rot)
        {
            case 1:
            case -3:
            mCoreMaze->rotWall(-1);
            break;
            case 2:
            case -2:
            mCoreMaze->rotWall(-1);
            mCoreMaze->rotWall(-1);
            break;
            case 3:
            case -1:
            mCoreMaze->rotWall(1);
            break;
        }
        mDialogMaze->close();
        mCoreMaze->terminate();
        mCoreMaze->wait();
        mTextToSpeech->say("Grazie per aver giocato");
        ui->labelWallUp->setStyleSheet("background-color:black");
        ui->labelWallLeft->setStyleSheet("background-color:black");
        ui->labelWallDown->setStyleSheet("background-color:black");
        ui->labelWallRight->setStyleSheet("background-color:black");
        ui->labelCornerTopLeft->setStyleSheet("background-color:black");
        ui->labelCornerTopRight->setStyleSheet("background-color:black");
        ui->labelCornerBottonLeft->setStyleSheet("background-color:black");
        ui->labelCornerBottonRight->setStyleSheet("background-color:black");
        ui->pushButton->setText("PLAY");
        this->flagStartStop = false;
    }
}
